/*
 * Created on 12.08.2004
 *
 * @author Jens Guenther
 */
package de.unirostock.AbstractFactory.example;


import javax.swing.JFrame;

import de.unirostock.AbstractFactory.example.awt.MainController;
import de.unirostock.AbstractFactory.example.awt.MainPanel;

public class Application
{
	public static void main(String[] args) 
	{
		MainPanel		mp		= new MainPanel();
		MainController	cntrl	= new MainController( mp );
		
		cntrl.setAvaiableShipFactorys( getShipFactorys());
		cntrl.init();
		
		JFrame	frame	= new JFrame( "AbstractFactory Beispiel");
		frame.setSize( 500, 350 );
		frame.setContentPane( mp );
		frame.setVisible( true );
	}
	
	private static ShipFactory[] getShipFactorys()
	{
		ShipFactory[] factorys	= new ShipFactory[4];
		factorys[0]	= SchniggeFactory.getShipFactory();
		factorys[1]	= KraierFactory.getShipFactory();
		factorys[2]	= KoggeFactory.getShipFactory();
		factorys[3]	= HolkFactory.getShipFactory();
		
		return factorys;
	}
}
